"use strict";
/**
 *    Copyright 2018 Panjie Setiawan Wicaksono
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
var ids_1 = require("./ids");
function errorInterceptor(opts) {
    if (opts === void 0) { opts = {}; }
    var defaultCondition = function (_, __, res) {
        return res.origin.status === 401;
    };
    var defaultRetry = function (fr, req) { return fr.request(req); };
    var authErrorInterceptor = function (err) {
        return new Promise(function (resolve, reject) {
            var _a = opts.count, count = _a === void 0 ? 0 : _a, _b = opts.delay, delay = _b === void 0 ? 1000 : _b, _c = opts.exp, exp = _c === void 0 ? 1 : _c, _d = opts.condition, condition = _d === void 0 ? defaultCondition : _d, _e = opts.doRetry, doRetry = _e === void 0 ? defaultRetry : _e;
            var frest = err.frest, request = err.request, response = err.response;
            var skip = request.skip;
            if (response &&
                (!skip || skip.indexOf(ids_1.ID_ERROR) < 0) &&
                count > 0 &&
                condition(frest, request, response) &&
                doRetry) {
                if (request.retry == null) {
                    request.retry = 0;
                }
                if (request.retry >= count) {
                    resolve(null);
                    return;
                }
                setTimeout(function () {
                    doRetry(frest, request, response)
                        .then(resolve)
                        .catch(reject);
                }, ++request.retry * delay * exp);
                return;
            }
            resolve(null);
        });
    };
    Object.defineProperty(authErrorInterceptor, 'id', { value: ids_1.ID_ERROR });
    return authErrorInterceptor;
}
exports.default = errorInterceptor;
